SourceForge has been redesigned. Learn more.
Close

#1 netbeans/User Tasks

open
nobody
Core (2)
5
2007-04-21
2007-02-06
hilt2
No

Hi,

I am a developer of the NetBeans "User Tasks" module (http://tasklist.netbeans.org). It seems that we work on similar projects. What do you think about some sort of collaboration (common data format, code reuse etc.)?

--Tim

Discussion

  • Zbigniew Ogledzki

    • labels: 731532 -->
     
  • Zbigniew Ogledzki

    Logged In: YES
    user_id=931945
    Originator: NO

    Dear hilt2,
    Thanks for your interest. But are you sure we are working on the same issue? I have looked at the web you provided but it seems to be something different :(
    TimeSlotTracker gathers information about user activity (working on some tasks), storing every timeslot (time period) individually. This is the biggest difference to almost all rest time-trackers - they usually sum this time and stores them in one attribute.

    But - in case I am wrong - my answer is generally "of course" :)
    --
    best regards, zgibek

     
  • Zbigniew Ogledzki

    Logged In: YES
    user_id=931945
    Originator: NO

    A, sorry, maybe my mistake.
    In what area you can the possibility to contribute/exchange experience, code or something else?
    regards, zgibek

     
  • hilt2

    hilt2 - 2007-02-07

    Logged In: YES
    user_id=634244
    Originator: YES

    Hello,

    here is my comparison of User Tasks (UT) and Time Slot Tracker (TST).
    Correct me if I am wrong somewhere!

    Data storage:
    ------------
    - UT stores data in an .ics file (RFC 2445) with extensions. TST stores it's data in it's own XML based format
    - UT can work with multiple .ics files. TST only allows 1 file in the home directory.

    Data model:
    -----------
    - UT sees an .ics file as a tree of tasks with additional dependencies between tasks.
    Tasks may act as categories and summarize values of subtasks.
    For TST a task list is also a tree of tasks. Additionally each task has a list of time slots.
    - Task attributes in UT: summary, details, category, owner, url, line, start date, due date, last modified time,
    completed time, "compute values automatically" flag, progress, effort, spent time, work periods, dependencies
    TST: name, description and generic attributes of 5 types

    Export:
    -------
    - UT allows export as .ics, html (6 different layouts), plain text and xml
    TST can export html (4 layouts), csv (2 layouts) and has additionally generic xslt+xml export

    Help:
    -----
    - UT: online help, TST: no

    i18n:
    ----
    - UT: yes, english only, TST: yes, polish, english and russian (I was not able to find the messages
    in the source code :-)

    App type:
    ---------
    - UT is a module for NetBeans (or any application based on NetBeans platform). TST is a standalone
    Java app.

    License:
    --------
    - UT: CDDL, TST: GPL. This combination is a problem (see http://www.gnu.org/philosophy/license-list.html\)

    ---------------------------------------------------------
    If you'd use subtasks instead of time slots then our data models would be compatible.
    The things where TST is ahead of UT are:
    - reports (I was not able to test them all)
    - generic attributes
    - localization in 3 languages

    So my first suggestion (probably not a realistic one) is:
    move this code to NetBeans CVS and help me with UT!

    What do you think?

    --Tim

     
  • hilt2

    hilt2 - 2007-02-15

    Logged In: YES
    user_id=634244
    Originator: YES

    It's more than a week since my last post and you didn't post an answer.
    What's going on?

    --Tim

     
  • Zbigniew Ogledzki

    • assigned_to: zgibek --> nobody
     
  • Zbigniew Ogledzki

    Logged In: YES
    user_id=931945
    Originator: NO

    Dear Tim,
    Sorry for this late answer, but I have been going live into production with one system... So I am busy nowadays..

    But, coming into your questions:
    > So my first suggestion (probably not a realistic one) is: move this code to NetBeans CVS and help me with UT!
    Yes, you are right - I don't see the possibility to moving to net beans.

    > UT is a module for NetBeans
    I don't want the Tst to be dependent on other software.

    > Data storage (...isc files...)
    Well, using well known, documented and open standards are good choice. I don't know this format, so maybe it would be good.
    But - xml is wildly portable, good to use on any platform, very easy to enhance and add new features.

    > Export (...)
    TsT can export data in any format - it depends only on xslt template. It could make also ics, pdf, txt, rft, ...
    You have only to write new xslt file.

    > localization (...) I was not able to find the messages in the source code (...)
    Because in the source code are ONLY code names of them. All strings are set in properties files.

    > License
    I want to keep the GPL licence.

    The thing we can cooperate for now is exchanging and coping/pasting data from/to ics/xml file.
    The other possibility is to make the user to choose the format to use ics datastore (if it fits the TsT needs)
    Another one - you can think about preparing reports with xslt.
    --
    best regards, zgibek

     
  • hilt2

    hilt2 - 2007-02-16

    Logged In: YES
    user_id=634244
    Originator: YES

    Hi,

    we cannot work on things together if you stick with GPL. I need at least LGPL or something similar to
    be able to reuse the results in my module.

    --Tim

     
  • hilt2

    hilt2 - 2007-02-16

    Logged In: YES
    user_id=634244
    Originator: YES

    You could use LGPL licensed content too. Please consider using LGPL if not for the whole TST
    than at least for parts we will use together.

     
  • hilt2

    hilt2 - 2007-02-23

    Logged In: YES
    user_id=634244
    Originator: YES

    Please contact me if you still interested in some sort of collaboration.

    --Tim

     
  • Zbigniew Ogledzki

    Logged In: YES
    user_id=931945
    Originator: NO

    Dear Tim,
    For now it has to be the GPL license model. It's just because of my very busy days.
    Changing the license model have to be very carefull. I don't know exactly the differences between GPL and LGPL
    - what they are?
    And what that mean for current users?

    The second thing is you don't reply about my point of view of exchanging code.
    --
    best regards, zgibek

     
  • Zbigniew Ogledzki

    • labels: --> Core
    • status: open --> closed
     
  • Zbigniew Ogledzki

    Logged In: YES
    user_id=931945
    Originator: NO

    Dear Tim,
    I am closing this request. It looks we are not going on the same train..
    Maybe in some future it will be possible.

    But, if your lack of answer is based just on busy days just let me know,
    I will put this task into open mode and wait for better time.
    --
    best regards, zgibek

     
  • hilt2

    hilt2 - 2007-04-21
    • status: closed --> open
     
  • hilt2

    hilt2 - 2007-04-21

    Logged In: YES
    user_id=634244
    Originator: YES

    Hi Zgibek,

    I did not get your reply from 2007-02-23 21:58. I don't know why.
    Maybe my Thunderbird filtered it out as a spam or there were some
    mail delivery problems. I would suggest to continue this discussion
    using e-Mail (tim dot lebedkov at web dot de). Some sort of chat
    would be also nice to speed things up.

    LGPL was designed especially for libraries and allows using of
    software for commercial purposes.

    Instead of exchanging code I would suggest to establish a
    library that will be used by both projects. The first thing
    that IMHO should go into it is the code modeling the tasks.

    Regards
    --Tim

     
  • Zbigniew Ogledzki

    Logged In: YES
    user_id=931945
    Originator: NO

    Dear Tim,

    On Saturday 21 of April 2007 10:44, you wrote:
    > I did not get your reply from 2007-02-23 21:58. I don't know why.
    > Maybe my Thunderbird filtered it out as a spam or there were some
    > mail delivery problems. I would suggest to continue this discussion
    > using e-Mail (tim dot lebedkov at web dot de). Some sort of chat
    > would be also nice to speed things up.
    Ok, never mind. Now you have my email :)
    But for other people IT IS IMPORTANT to copy it to source forge.

    > LGPL was designed especially for libraries and allows using of
    > software for commercial purposes.
    What does mean the commercial purposes - in which area?

    > Instead of exchanging code I would suggest to establish a
    > library that will be used by both projects. The first thing
    > that IMHO should go into it is the code modeling the tasks.
    Building library for both project is a project in intself, but...
    I think we should rather consider exchanging underlaying data, something like import/export.
    This should show us where are the differences and what have to be done to integrate them.
    And it doesn't require to change the licence model.

    So, the format used by TimeSlotTracker is well know and wrote in dtd file, as well as sample (or real one if you us it :)) xml file with data.
    Can you compare it to netbeans and describe, one by one, where are the differences.
    --
    best regards, zgibek

     
  • hilt2

    hilt2 - 2007-04-21

    Logged In: YES
    user_id=634244
    Originator: YES

    Hello Zbigniew,

    Zbigniew Oględzki wrote:
    > Dear Tim,
    >
    > On Saturday 21 of April 2007 10:44, you wrote:
    >> I did not get your reply from 2007-02-23 21:58. I don't know why.
    >> Maybe my Thunderbird filtered it out as a spam or there were some
    >> mail delivery problems. I would suggest to continue this discussion
    >> using e-Mail (tim dot lebedkov at web dot de). Some sort of chat
    >> would be also nice to speed things up.
    > Ok, never mind. Now you have my email :)
    > But for other people IT IS IMPORTANT to copy it to source forge.
    I will duplicate my answers there.
    >
    >> LGPL was designed especially for libraries and allows using of
    >> software for commercial purposes.
    > What does mean the commercial purposes - in which area?
    A LGPL-licensed library can be shipped with a closed source
    commercial application without any restrictions and without
    open-sourcing the code of the application.
    >
    >> Instead of exchanging code I would suggest to establish a
    >> library that will be used by both projects. The first thing
    >> that IMHO should go into it is the code modeling the tasks.
    > Building library for both project is a project in intself, but...
    > I think we should rather consider exchanging underlaying data, something
    > like import/export.
    I myself don't need to import data from timeslottracker and
    none of the users of UT asked me to do it. It is not enough for me
    to exchange data.
    > This should show us where are the differences and what have to be done to
    > integrate them.
    > And it doesn't require to change the licence model.
    >
    > So, the format used by TimeSlotTracker is well know and wrote in dtd file,
    > as well as sample (or real one if you us it :)) xml file with data.
    > Can you compare it to netbeans and describe, one by one, where are the
    > differences.
    I have already compared data models. Here we go:

    Data model:
    -----------
    - UT sees an .ics file as a tree of tasks with additional dependencies
    between tasks.
    Tasks may act as categories and summarize values of subtasks.
    For TST a task list is also a tree of tasks. Additionally each task has
    a list of time slots.
    - Task attributes in UT: summary, details, category, owner, url, line,
    start date, due date, last modified time,
    completed time, "compute values automatically" flag, progress, effort,
    spent time, work periods, dependencies
    TST: name, description and generic attributes of 5 types
    If you'd use subtasks instead of time slots then our data models would be
    compatible.

    Please also consider one more time moving the code of TST to a
    NB module. Due to the recent changes the software now does not depend on
    NetBeans as application anymore, only as platform. You can download
    current version from
    http://tasklist.netbeans.org/servlets/ProjectDocumentList?folderID=163&expandFolder=163&folderID=0
    It is only 6 MB.

    Regards
    --Tim

     

Log in to post a comment.